#!/usr/bin/perl -w
use strict;
use Mysql;
use lib $ENV{SPQRLIB};
use Storage;
use timestamp;
use Session;

my ($precfwd, $precbwd);
my $record;
my $usage="Usage: ./session.pl <config file>\n";

$|=1;
if ( ! defined $ARGV[0] ) {
    die $usage
    }

#######################
# New session opening #
#######################
my $s = 'Session'->new($ARGV[0]);
# Discriminate text only vs SQL output
if ( defined $s->{SQLserver} ) {
# SQL case
    $s->open($s);
    $record=Storage::newStorage($s);
    
# Manca l'aggiornamento del database SQL con la proposta del target;
} else {
# Text only case
##### Print Version line #####
    printf "V %s\n", $s->{version};
##### Print Probe request line #####
    printf "P %s \t%s \t%6u \t%2.2f \t%6u \t%2u\n", 
    $s->{probeIP}, $s->{targetIP}, $s->{port}, 
    $s->{period}, $s->{length}, $s->{scale};
    $s->open($s);
##### Print Target reply line #####
    printf "T %2.2f \t%6u \t%2u\n",
    $s->{period}, $s->{length}, $s->{scale};
##### Print close line
    print ". \n";
}

#print "signature: $s->{signature}\n";

##### Start looping
while ( 1 ) {
# Ping
    my @t;
    my @ref=unpack("LL",nowtval());
    eval { @t=$s->ping($s); };
    if ( $@ ) {
# La seguente pare un po' forte...
# ma la gestione di una sessione interrotta
# per un motivo diverso dal messaggio perso dovrebbe
# stare nello script di invocazione (vedi gluedomains)
	die unless $@ eq "Backward message timed out!\n";
	printf "? %10lu: %s\n", time(),$@; 
	( $@ eq "Backward message timed out!\n" ) ||
# Sleep until next round if no timeout occurred
	    select(undef, undef, undef, $s->{period});
	next;
    }

#    print "$t[0],$t[1],$t[2],$t[3]\n";
if ( defined $s->{SQLserver} ) {
    $record->Storage::insert(
			     $ref[0],
			     $ref[1],
			     $t[0],
			     diffmod($t[1],$t[0]),
			     diffmod($t[2],$t[1]),
			     diffmod($t[3],$t[2])
			     );
    print ".";
} else {
# Generate float timestamp of T_0
    my $time=tstofloat($s->{scale}, $t[0]);
# Compute raw delta
    my $diff_fwd=sdifftofloat(diffmod($t[1],$t[0]),$s->{scale});
    my $diff_lat=sdifftofloat(diffmod($t[2],$t[1]),$s->{scale});
    my $diff_bwd=sdifftofloat(diffmod($t[3],$t[2]),$s->{scale});
##### Print a one line report (see paper for format) #####
    printf "< %10lu \t%5.6f \t%5.6f \t%5.6f\t%5.6f\n",
    time(), $time, $diff_fwd, $diff_lat, $diff_bwd;
}
# Sleep until next round
    select(undef, undef, undef, $s->{period});
}




