package SQLjmeter;
use timestamp;
use strict;

BEGIN{
    require Exporter;
    use vars qw(@ISA @EXPORT);
    @ISA = qw(Exporter);
    @EXPORT = qw(&connect &findseries &getparms &getscale 
		 &getskew);
}

sub connect {
    my ($server,$user,$database) = @_;
    my $password;
    system('stty -echo');
    print "Password for SQL database $database at $server as $user: ";
    chomp ($password=<STDIN>);
    print "\n";
    system('stty echo');
    
    return Mysql->connect(
			  $server,
			  $database,
			  $user,
			  $password
			  );
}    

# Questa  da rivedere, perch preleva i dati da un'unica serie!
sub getdelayoffset {
    my ($dbh,$probe,$target,$time,$lapse) = @_;
    my $i;
    my @table;
    my @result;
    
# Find series parameters
    my $id=$dbh->SQLjmeter::findseries($probe,$target,$time); 
    (defined $id) || die "Data not available\n";
    my ($scale, $fwdskew, $fwdintercept, $bwdskew, $bwdintercept) = 
	$dbh->SQLjmeter::getparms($id);
#   print "$scale, $fwdskew, $fwdintercept, $bwdskew, $bwdintercept\n";
# Queries data records
    my $sth=$dbh->query(
	     "SELECT UNIX_TIMESTAMP(timestamp),diffFwd,diffBwd 
              FROM NetworkVerbosePingData
              WHERE identifier=$id and ABS(UNIX_TIMESTAMP(timestamp)-
                                           UNIX_TIMESTAMP(\"$time\")
                                          ) < $lapse;")
	or die $!;
    @table=@{$sth->fetchall_arrayref}
        or die;
    @table=sort { $a->[0] <=> $b->[0] } @table; 
    
   
# Computes delay offsets (forward and backward), from scaled differences
    for ($i=0;$i<=$#table;$i++) {
	$result[$i][0]=$table[$i][0];
	$result[$i][1]=sdifftofloat($table[$i][1],$scale) -
	    ( ($fwdskew*$table[$i][0]) + $fwdintercept );
	$result[$i][2]=sdifftofloat($table[$i][2],$scale) -
	    ( ($bwdskew*$table[$i][0]) + $bwdintercept );
	$result[$i][3]=sdifftofloat($table[$i][1]+$table[$i][2],$scale);
    }
    return (\@result,$fwdskew, $fwdintercept, $bwdskew, $bwdintercept);
}

sub findseries {
    my ($dbh,$probe,$target,$time) = @_;
    my $sth = $dbh->query(
       "SELECT NetworkVerbosePing.identifier
       FROM NetworkVerbosePing, NetworkVerbosePingData
       WHERE nmidSource=\"$probe\" and nmidTarget=\"$target\"
       and NetworkVerbosePingData.identifier = NetworkVerbosePing.identifier
       and ABS(UNIX_TIMESTAMP(timestamp)-UNIX_TIMESTAMP(\"$time\")) < 600;")
	|| die;
    return $sth->fetchrow;
}
    
sub getparms {
    my ($dbh,$id) = @_;
    my $s=$dbh->SQLjmeter::getscale($id);
    my ($fa,$fb) = $dbh->SQLjmeter::getskew($id, $s, "fwd");
    my ($ba,$bb) = $dbh->SQLjmeter::getskew($id, $s, "bwd");
    return ($s, $fa, $fb, $ba, $bb);
}


sub getscale {
    my ( $dbh, $id ) = @_;
    my $sth=$dbh->query(
      "SELECT scale 
       FROM NetworkVerbosePing
       WHERE identifier=$id;")
	or die "Can't get scale";
    return $sth->fetchrow;
}

sub getskew {
    my ( $dbh, $id, $scale, $direction ) = @_;
    my $dirname;
  SWITCH: {
      if ( $direction eq "fwd" ) { $dirname="Fwd";last SWITCH;}
      if ( $direction eq "bwd" ) { $dirname="Bwd";last SWITCH;}
      die "Wrong direction parameter to getskew\n";
  }
#    print "$dirname\n";
# fetch potential minimum 
    my $sth=$dbh->query(
      "SELECT UNIX_TIMESTAMP(timestamp),diff$dirname
       FROM NetworkVerbosePingData
       WHERE identifier=$id
       and pmd$dirname is not NULL;")
	or die $!;
    my @table=sort { $a->[0] <=> $b->[0] } @{$sth->fetchall_arrayref};
    
    
# guess real minimum using maximum difference criteria
    my $maxdiff=0;
    my $guess;
    my $i;
    for ($i=1;$i<=$#table;$i++) {
	if ( ( $table[$i][0] - $table[$i-1][0] ) > $maxdiff ) {
	    $guess=$i;
	    $maxdiff = $table[$i][0] - $table[$i-1][0];
	}
    }   
    
#    print "$guess $table[$guess][1] $table[$guess-1][1] ";
#    print "$table[$guess-1][1] $table[$guess][1]";
#    print " ";
#    print tstofloat($scale,$table[$guess-1][0]) - tstofloat($scale,$table[$guess][0]);
#    print "\n";

#compute predicted clock skew
    my $skew = 
	( sdifftofloat($table[$guess-1][1],$scale) - 
	  sdifftofloat($table[$guess][1],$scale) 
	  ) / 
	  ( $table[$guess-1][0] - $table[$guess][0] );
    my $intercept =  sdifftofloat($table[$guess][1],$scale) - 
                     ( $skew * $table[$guess][0] );
#    print "$skew $intercept $table[$guess][0] ".sdifftofloat($table[$guess][1],$scale)."\n";
#    print $skew*$table[$guess][0]+$intercept."\n";
#    print "$skew, $intercept\n";
    return ( $skew, $intercept );
}

1;

