package packet;
use strict;
use timestamp;
require 'sys/syscall.ph';

BEGIN{
    require Exporter;
    use vars qw(@ISA @EXPORT @EXPORT_OK);
    @ISA = qw(Exporter);
    @EXPORT = qw( &tsrecv &tssend );
    @EXPORT_OK = qw( %messageType $maxbuffer );
}

use vars      @EXPORT_OK;

%messageType= (
	       open => 0x1,
	       reply => 0x2,
	       forward => 0x3,
	       backward => 0x4,
	       );

$maxbuffer=0x400;

# Non si pu restituire subito un timestamp perch il target
# pu non conoscerlo ancora. Restituisce un timeval.
sub tsrecv {
    my $addr=recv($_[0],$_[1],$maxbuffer,0);
    ( defined $addr ) || die "recv: $!";
    my $now=nowtval;
    return ($addr, $now);
}

# Andrebbe definita la variante che mette il timestamp prodotto
# in una collocazione data del pacchetto. Questa restituisce un 
# timestamp
sub tssend {
    my $now=nowts($_[2]);
    defined( send ($_[0], $_[1], 0) )
	|| die "send: $!";
    return ($now);
}

1;



















